const TblArtigosEmUso = require("../models/TblArtigosEmUso");

const getAllArtigosEmUso = async (queryParams = {}) => {
  return TblArtigosEmUso.findAll({
    where: queryParams,
  });
};

const getArtigoEmUsoById = async (id, queryParams = {}) => {
  const whereCondition = { intId: id, ...queryParams };

  return TblArtigosEmUso.findOne({
    where: whereCondition,
  });
};

const createArtigoEmUso = async (artigoEmUsoData) => {
  return TblArtigosEmUso.create(artigoEmUsoData);
};

const updateArtigoEmUso = async (id, artigoEmUsoData) => {
  const artigoEmUso = await TblArtigosEmUso.findByPk(id);
  if (!artigoEmUso) {
    throw new Error("ArtigoMaquina not found");
  }
  return artigoEmUso.update(artigoEmUsoData);
};

const deleteArtigoEmUso = async (id) => {
  // Assuming TblArtigoMaquina is your Sequelize model
  const result = await TblArtigosEmUso.update(
    { bitEliminado: true },
    { where: { intId: id } }
  );

  // The 'result' object contains information about the operation
  const affectedRows = result[0];

  if (affectedRows === 0) {
    throw new Error("ArtigoEmUso not found");
  }

  // You might want to return additional information if needed
  return { success: true, message: "ArtigoEmUso soft deleted successfully" };
};

module.exports = {
  getAllArtigosEmUso,
  getArtigoEmUsoById,
  createArtigoEmUso,
  updateArtigoEmUso,
  deleteArtigoEmUso,
};
